//https://www.geeks3d.com/20140807/billboarding-vertex-shader-glsl/

layout(location = 0) in vec4 aPosition;
layout(location = 1) in vec2 aTexCoord;
layout(location = 2) in vec3 aNormal;

uniform mat4 uView;
uniform mat4 uProjection;
uniform mat4 uModel;

layout(std140, row_major) uniform Global
{
	float time;
} global;


out vec2 vUV;
out vec3 vWorldNormal;
out vec3 vWorldPosition;
out vec4 vClipSpace;

#ifdef SHADOW
void main()
{
	mat4 viewModel = uView * uModel;
	// Column 0:
	viewModel[0][0] = uModel[0][0];
	viewModel[0][1] = 0;
	viewModel[0][2] = 0;

	// Column 1:
	viewModel[1][0] = 0;
	viewModel[1][1] = uModel[0][0];
	viewModel[1][2] = 0;

	// Column 2:
	viewModel[2][0] = 0;
	viewModel[2][1] = 0;
	viewModel[2][2] = uModel[0][0];
	
	gl_Position = uProjection * viewModel * aPosition;
	vClipSpace = gl_Position;
}
#else
void main()
{
	mat4 viewModel = uView * uModel;
	// Column 0:
	viewModel[0][0] = uModel[0][0];
	viewModel[0][1] = 0;
	viewModel[0][2] = 0;

	// Column 1:
	viewModel[1][0] = 0;
	viewModel[1][1] = uModel[0][0];
	viewModel[1][2] = 0;

	// Column 2:
	viewModel[2][0] = 0;
	viewModel[2][1] = 0;
	viewModel[2][2] = uModel[0][0];
	
	gl_Position = uProjection * viewModel * aPosition;
	vClipSpace = gl_Position;
	vWorldPosition = vec3(uModel * aPosition);

	vWorldNormal = mat3(transpose(inverse(uModel))) * aNormal;

	vUV = aTexCoord;
}
#endif