
layout(location = 0) out vec4 color;

in vec2 vertex_uv;
in vec3 world_normal;
in vec3 world_position;

uniform samplerCube cubemap;
uniform vec3 u_camera_world_pos;

layout(std140, row_major) uniform Global
{
	float time;
} global;


void main()
{
	vec3 I = normalize(world_position - u_camera_world_pos);
	vec3 R = reflect(I, normalize(world_normal));
	color = pow(vec4(texture(cubemap, R).rgb, 1.0), vec4(2.2));
	//color = vec4(textureLod(cubemap, R, (sin(global.time * 0.5) + 1.0) * 5 ).rgb, 1.0);
}