
layout(location = 0) in vec4 position;
layout(location = 1) in vec2 texCoord;
layout(location = 2) in vec3 normal;

uniform mat4 u_view;
uniform mat4 u_projection;
uniform mat4 u_model;

layout(std140, row_major) uniform Global
{
	float time;
} global;


out vec2 vertex_uv;
out vec3 world_normal;
out vec3 world_position;

void main()
{
	vec4 newPos = position + vec4(0, sin(global.time) * 2.0, 0 ,0);
	gl_Position = u_projection * u_view * u_model * newPos ;
	world_position = vec3(u_model * newPos);
	world_normal = mat3(transpose(inverse(u_model))) * normal;
	world_normal = normalize(world_normal);
	vertex_uv = texCoord;
}