
layout (location = 0) out vec4 fWorldNormal;
layout (location = 1) out vec4 fAlbedoRoughness;
layout (location = 2) out vec3 fEmissive;

in vec2 vUV;
in vec3 vWorldNormal;
in vec3 vWorldPosition;

uniform sampler2D uDiffuseTexture;

layout(std140, row_major) uniform Global
{
	float time;
} global;


#ifdef SHADOW
void main()
{

}
#else
void main()
{
	// calculate normal from normal map
	fWorldNormal.xyz  =  normalize(vWorldNormal).xyz;
	fWorldNormal.w = 0.0f;
	
	// sRGB to linear
	fAlbedoRoughness.rgb = pow(texture(uDiffuseTexture, vUV).rgb, vec3(2.2));
	fAlbedoRoughness.a = 0.2;
	
	fEmissive = vec3(0);
}
#endif