
layout(location = 0) in vec4 aPosition;
layout(location = 1) in vec2 aTexCoord;
layout(location = 2) in vec3 aNormal;

uniform mat4 uView;
uniform mat4 uProjection;
uniform mat4 uModel;

layout(std140, row_major) uniform Global
{
	float time;
} global;


out vec2 vUV;
out vec3 vWorldNormal;
out vec3 vWorldPosition;

#ifdef SHADOW
void main()
{
	gl_Position = uProjection * uView * uModel * aPosition;
}
#else
void main()
{
	gl_Position = uProjection * uView * uModel * aPosition;

	vWorldPosition = vec3(uModel * aPosition);

	vWorldNormal = mat3(transpose(inverse(uModel))) * aNormal;

	vUV = aTexCoord;
}
#endif