
layout (location = 0) out vec4 fWorldNormal;
layout (location = 1) out vec4 fAlbedoRoughness;
layout (location = 2) out vec3 fEmissive;

in vec2 vUV;
in vec3 vWorldNormal;
in vec3 vWorldPosition;
in mat3 vTBN;

uniform sampler2D uDiffuseTexture;
uniform sampler2D uRoughnessTexture;
uniform sampler2D uNormalTexture;

layout(std140, row_major) uniform Global
{
	float time;
} global;

//calculate new world normal from  TBN & normal map
vec3 calcNormal()
{
	vec3 n = texture(uNormalTexture, vUV).rgb;
	//n.g = 1 - n.g;
	n = normalize(n * (255.0/128.0) - 1.0);   
	n = normalize(vTBN * n); 
	return n;
}

#ifdef SHADOW
void main()
{

}
#else
void main()
{
	// calculate normal from normal map
	fWorldNormal.xyz  = calcNormal();
	fWorldNormal.w = 0.0f;
	// sRGB to linear
	fAlbedoRoughness.rgb = pow(texture(uDiffuseTexture, vUV).rgb, vec3(2.2));

	fAlbedoRoughness.a = texture(uRoughnessTexture, vUV).r;
// apha masking test 
//	if(fAlbedoRoughness.a > 0.95)
//		discard;

	//float phase = (sin(global.time * 3.0) + 1.0) * 0.5; 
	//fEmissive = phase * vec3(1.0);
}
#endif