
layout (location = 0) out vec4 fWorldNormal;
layout (location = 1) out vec4 fAlbedoRoughness;
layout (location = 2) out vec3 fEmissive;

in vec2 vUV;
in vec3 vWorldNormal;
in vec3 vWorldPosition;

uniform sampler2D uTexture;

layout(std140, row_major) uniform Global
{
	float time;
} global;


#ifdef SHADOW
void main()
{
	vec4 tex = texture(uTexture, vUV);
	
	if(tex.w < 1)
	{
		discard;
	}
	
}
#else
void main()
{
	vec4 tex = texture(uTexture, vUV);
	
	if(tex.w < 1)
	{
		discard;
	}
	
	// calculate normal from normal map
	fWorldNormal.xyz  =  normalize(vWorldNormal).xyz;
	fWorldNormal.w = 0.0f;
	
	// sRGB to linear
	fAlbedoRoughness.rgb = pow(tex.rgb, vec3(2.2)) * vec3( 0.464, 1.0, 0.4731);
	fAlbedoRoughness.a = 0.2;
	
	
	
	fEmissive = vec3(0);
}
#endif