layout(location = 0) out vec3 color;

in vec2 uv;

uniform sampler2D uCustomDepth;
uniform vec3 uOutlineColor;
uniform float uOutlineThickness;

float near_plane = 0.1;
float far_plane = 1000.0;

float LinearizeDepth(float depth)
{
    float z = depth * 2.0 - 1.0; // Back to NDC 
    return (2.0 * near_plane * far_plane) / (far_plane + near_plane - z * (far_plane - near_plane));	
}

#define sample(x, y) (LinearizeDepth(texture2D( uCustomDepth, uv + offset * vec2(x, y)).r) / far_plane)

void main()
{
	vec2 offset = vec2(1.0 / textureSize(uCustomDepth, 0)) * uOutlineThickness;
	
	float outline = (abs(sample(-1, -1) - sample(1, 1)) + abs(sample(1, -1) - sample(-1, 1))) / 2.0;

	color = uOutlineColor * min( 1.0, max(outline, 0.0));
}