

layout(location = 0) in vec4 aPosition;
layout(location = 1) in vec2 aTexCoord;
layout(location = 2) in vec3 aNormal;

uniform mat4 u_view;
uniform mat4 u_projection;
uniform mat4 u_model;
uniform mat4 u_lightMatrix; // light matrix

out vec2 vertex_uv;
out vec3 world_normal;
out vec3 world_position;
out vec4 light_position;

layout(std140, row_major) uniform Global
{
	float time;
} global;

void main()
{
	world_position = vec3(u_model * aPosition);

	light_position = u_lightMatrix * vec4(world_position, 1.0);

	gl_Position = u_projection * u_view * u_model * aPosition ;
	
	vertex_uv = aTexCoord;

	world_normal = mat3(transpose(inverse(u_model))) * aNormal;
	world_normal = normalize(world_normal);
}