
layout(location = 0) out vec4 color;

in vec2 vertex_uv;
in vec3 world_normal;
in vec3 world_position;

uniform sampler2D tex;
uniform vec3 u_camera_world_pos;

//Colors for the poles
vec4 colorA = vec4(0.000, 0.455, 0.851, 1.0);
vec4 colorB = vec4(0.694, 0.051, 0.788, 1.0);


layout(std140, row_major) uniform Global
{
	float time;
} global;


vec4 DirectionalLight( vec3 direction, vec3 color)
{
	direction = normalize(-direction);
	
	float ambient_strength = 0.0f;
    vec3 ambient = vec3(0.0f, 0.0f, 0.0f);
	
	float diffuse = max(0.0f, dot(world_normal, direction));
	
	float specular_strength = 1.0;
	vec3 reflect_dir = reflect(-direction, world_normal);
	vec3 eye = normalize(u_camera_world_pos - world_position);
	float specular = specular_strength * pow(max(0.0f ,dot(eye, reflect_dir)), 32.0f); //32.0f->shininess factor
	
	return vec4(ambient + diffuse + specular, 1.0f) * vec4(color, 1);
}

vec4 calcAmbientLighting()
{
	float alpha = dot(world_normal, vec3( 0,1, 0));
	alpha = (alpha + 1) * 0.5f;
	return mix(colorA, colorB, alpha) * 0.1;
}


//unlit
void main()
{
	color = pow(vec4(texture(tex, vertex_uv).rgb, 1.0), vec4(2.2));
}