

layout(location = 0) in vec4 position;
layout(location = 1) in vec2 texCoord;
layout(location = 2) in vec3 normal;

uniform mat4 u_view;
uniform mat4 u_projection;
uniform mat4 u_model;

out vec2 vertex_uv;
out vec3 world_normal;
out vec3 world_position;

layout(std140, row_major) uniform Global
{
	float time;
} global;

void main()
{
	gl_Position = u_projection * u_view * u_model * position ;
	vertex_uv = texCoord;
	world_position = vec3(u_model * position);
	world_normal = mat3(transpose(inverse(u_model))) * normal;
	world_normal = normalize(world_normal);
}